* New Qlib_ext QL - with QW, QX, QX_JOB0, & FREE added
*
* V3.36,  Liberation Software, 1993
* V3.42, PW, 2021 Oct 27
*

	section code

	include dev8_keys_sys
	include dev8_keys_qdos_io
	include dev8_keys_sbasic
	include dev8_keys_qlv
	include dev8_keys_err

	xdef Q_CURSOFF,Q_CURSON
	xdef QJ,QP,QR
	xdef QW,QX,QX_JOB0
	xdef Q_MYJOB,FREE

*

Q_CURSOFF
L00DA	bsr.s	L00EA
	moveq	#$0F,d0 	; IOW_DCUR
	bra.s	L00E4

Q_CURSON
L00E0	bsr.s	L00EA
	moveq	#$0E,d0 	; IOW_ECUR
L00E4	moveq	#-$01,d3
	trap	#$03
	rts
* 
L00EA	movea.l a5,a4
	cmpa.l	a3,a5
	  beq.s L011A
	tst.b	$01(a6,a3.l)
	  bpl.s L011A
	lea	$0008(a3),a5
	movea.w $00000112,a2
	jsr	(a2)
	movea.l a5,a3
	movea.l a4,a5
	  bne.s L011A
	move.w	$00(a6,a1.l),d0
L010A	mulu.w	#$0028,d0
	movea.l $0030(a6),a0
	adda.w	d0,a0
	movea.l $00(a6,a0.l),a0
	rts
* 
L011A	moveq	#$01,d0
	bra.s	L010A

*
Q_MYJOB
L011E	moveq	#$02,d1
	movea.w $0000011A,a2
	jsr	(a2)
	movea.l $0058(a6),a1
	subq.l	#$02,a1
	move.l	a1,$0058(a6)
	moveq	#$00,d0 	; SMS_INFO
* 
	trap	#$01
	move.w	d1,$00(a6,a1.l)
	moveq	#$03,d4
	moveq	#$00,d0
	rts

*
QR
L013E	bsr.s	L017E
	  bne.s L0162
	moveq	#$00,d3
	cmpa.l	a4,a5
	  beq.s L014A
	bsr.s	L0168
L014A	move.l	d4,d1
	moveq	#$05,d0 	; SMS_FRJB
	trap	#$01
	rts

*
QP
L0152	bsr.s	L017E
	  bne.s L0162
	bsr.s	L0168
	move.w	d3,d2
	  bmi.s L0164
	move.l	d4,d1
	moveq	#$0B,d0 	; SMS_SPJB
	trap	#$01
L0162	rts
* 
L0164	moveq	#-$0F,d0	; ERR_IPAR
	rts
* 
L0168	movea.l a5,a3
	movea.l a4,a5
	movea.w $00000112,a2
	jsr	(a2)
	  bne.s L017A
	move.w	$00(a6,a1.l),d3
	rts
* 
L017A	addq.l	#$04,a7
	rts
* 
L017E	cmpa.l	a3,a5
	  ble	L020A
	movea.l a5,a4
	moveq	#$00,d5
	lea	$0008(a3),a5
	tst.b	$00(a6,a3.l)
	  beq.s L01C2
	moveq	#$0F,d0
	and.b	$01(a6,a3.l),d0
	subq.b	#$01,d0
	  beq.s L01E6
	movea.w $00000112,a2
	jsr	(a2)
	  bne.s L020A
	move.w	$00(a6,a1.l),d3
	move.l	$00(a6,a1.l),d4
	moveq	#$00,d0 	; SMS_INFO
	trap	#$01
	movea.l $0068(a0),a0	; SYS_JBTB
	lsl.w	#$02,d3
	move.l	$00(a0,d3.w),d0
	  bmi.s L020A
	movea.l d0,a2
	bra	L0242
* 
L01C2	move.w	$02(a6,a3.l),d0
	  bmi.s L020A
	lsl.w	#$03,d0
	add.l	$0018(a6),d0
	movea.l d0,a3
	movea.l $0020(a6),a1
	moveq	#$00,d2
	move.w	$02(a6,a3.l),d2
	adda.l	d2,a1
	move.b	$00(a6,a1.l),d5
	lea	$0001(a1),a1
	bra.s	L01F4
L01E6	movea.w $00000116,a2
	jsr	(a2)
	  bne.s L020A
	move.w	$00(a6,a1.l),d5
	addq.l	#$02,a1
L01F4	moveq	#$00,d0 	; SMS_INFO
	trap	#$01
	move.l	$006C(a0),d3	; SYS_JBTT
	movea.l $0068(a0),a0	; SYS_JBTB
	moveq	#$00,d4
L0202	addq.l	#$04,a0
	addq.l	#$01,d4
	cmpa.l	d3,a0
	  bne.s L020E
L020A	moveq	#-$02,d0	; ERR_IJOB
	rts
* 
L020E	move.l	(a0),d6
	  bmi.s L0202
	movea.l d6,a2
	adda.w	#$006E,a2
	cmpi.w	#$4AFB,(a2)+
	  bne.s L0202
	cmp.w	(a2)+,d5
	  bne.s L0202
	movem.l d5/a1,-(a7)
	moveq	#$20,d2
L0228	move.b	(a2)+,d0
	move.b	$00(a6,a1.l),d1
	or.b	d2,d1
	or.b	d2,d0
	cmp.b	d0,d1
	  bne.s L024C
	addq.l	#$01,a1
	subq.w	#$01,d5
	  bne.s L0228
	addq.l	#$08,a7
	swap	d4
	movea.l d6,a2
L0242	move.w	$0010(a2),d4
	swap	d4
	moveq	#$00,d0
L024A	rts
* 
L024C	movem.l (a7)+,d5/a1
	bra.s	L0202
L0252	moveq	#$2B,d0 	; IOW_SULA
	moveq	#-$01,d3
	trap	#$03
	rts

*
QJ
L025A	bsr	L00EA
	move.l	a0,d7
	moveq	#$00,d4
	cmpa.l	a3,a5
	  beq.s L026C
	bsr	L017E
	  bne.s L024A
L026C	movea.l d7,a0
	moveq	#$01,d1
	bsr.s	L0252
	lea	L03D6(pc),a1
	movea.w $000000D0,a2	; UT_WTEXT
	jsr	(a2)
	moveq	#$00,d1
	bsr.s	L0252
	move.l	d4,d5
L0282	move.l	d4,d1
	ext.l	d1
	moveq	#$03,d0
	bsr	L0370
	move.l	d4,d1
	move.l	d5,d2
	movea.l a0,a2
	moveq	#$02,d0 	; SMS_INJB
	trap	#$01
	tst.l	d0
	  bne	L0344
	exg	a0,a2
	move.l	d4,d6
	move.l	d1,d4
	ext.l	d2
	move.l	d2,d1
	moveq	#$05,d0
	bsr	L0370
	tst.l	d6
	  bne.s L02C2
	move.l	a0,-(a7)
	moveq	#$00,d0 	; SMS_INFO
	trap	#$01
	move.l	$0014(a0),d1	; SYS_TPAB
	sub.l	$0010(a0),d1	; SYS_MPAB
	movea.l (a7)+,a0
	bra.s	L02C6
L02C2	move.l	-$0068(a2),d1
L02C6	divu.w	#$0400,d1
	move.l	d1,d0
	ext.l	d1
	swap	d0
	tst.w	d0
	  beq.s L02D6
	addq.l	#$01,d1
L02D6	moveq	#$05,d0
	bsr	L0370
	lea	L03D0(pc),a1
	bsr	L03C0
	moveq	#$20,d1
	move.w	-$0054(a2),d0
	  bpl.s L02F4
	moveq	#$53,d1
	addq.w	#$01,d0
	  beq.s L02F4
	moveq	#$57,d1
L02F4	bsr.s	L0368
	bsr.s	L0362
	moveq	#$00,d1
	move.b	-$0055(a2),d1
	moveq	#$03,d0
	bsr.s	L0370
	bsr.s	L0362
	moveq	#$51,d1
	cmpi.w	#$0002,$002C(a2)
	  blt.s L0316
	cmpi.w	#$0004,$002C(a2)
	  ble.s L0318
L0316	moveq	#$20,d1
L0318	bsr.s	L0368
	bsr.s	L0362
	tst.l	d6
	  bne.s L032A
	lea	L0404(pc),a1
	bsr	L03C0
	bra.s	L033C
L032A	cmpi.w	#$4AFB,$0006(a2)
	  bne.s L033C
	lea	$0008(a2),a1
	movea.w $000000D0,a2	; UT_WTEXT
	jsr	(a2)
L033C	bsr.s	L0366
	tst.l	d4
	  bne	L0282
L0344	bsr.s	L0366
	move.l	a0,-(a7)
	moveq	#$06,d0 	; SMS_FRTP
	trap	#$01
	movea.l (a7)+,a0
	moveq	#$00,d0
	subi.l	#$00000400,d1
	bsr.s	L0370
	lea	L03F6(pc),a1
	bsr.s	L03C0
	moveq	#$00,d0
	rts
* 
L0362	moveq	#$20,d1
	bra.s	L0368
L0366	moveq	#$0A,d1
L0368	moveq	#$05,d0 	; IOB_SBYT
	moveq	#-$01,d3
	trap	#$03
	rts
* 
L0370	movem.l d0-d3,-(a7)
	movea.l a7,a1
	subq.l	#$08,a7
	moveq	#$00,d2
L037A	move.w	d1,-(a7)
	clr.w	d1
	swap	d1
	divu.w	#$000A,d1
	move.w	d1,d0
	move.w	(a7)+,d1
	divu.w	#$000A,d1
	swap	d1
	ori.b	#$30,d1
	move.b	d1,-(a1)
	addq.l	#$01,d2
	move.w	d0,d1
	swap	d1
	tst.l	d1
	  bne.s L037A
	move.l	$0008(a7),d1
	  beq.s L03B2
	sub.l	d2,d1
	  ble.s L03B2
L03A8	move.b	#$20,-(a1)
	addq.l	#$01,d2
	subq.w	#$01,d1
	  bne.s L03A8
L03B2	moveq	#-$01,d3
	moveq	#$07,d0 	; IOB_SMUL
	trap	#$03
	addq.l	#$08,a7
	movem.l (a7)+,d0-d3
	rts
* 
L03C0	movem.l d0-d3/a1-a3,-(a7)
	movea.w $000000D0,a2	; UT_WTEXT
	jsr	(a2)
	movem.l (a7)+,d0-d3/a1-a3
	rts
* 
L03D0	dc.b	$00,$03,$20,$20,$00
L03D6	dc.b	$00,$1E,$0A,'Job Owner'
	dc.b	' Size '
	dc.b	'Priority Name',$0A
L03F6	dc.b	$00,$0C,' bytes free',$0A
L0404	dc.b	$00,$05,'BASIC',$00

*
QW
L055C	moveq	#-$01,d6
	clr.w	d6
	moveq	#-$01,d7
	bra.s	L056C

*
QX_JOB0
L0564	moveq	#$00,d7
	bra.s	L056A

*
QX
L0568	moveq	#-$01,d7
L056A	moveq	#$00,d6
L056C	sf	$00DA(a6)
	cmpa.l	a3,a5
	  beq.s L05C4
	movea.l a5,a4
	lea	$0008(a3),a5
	bsr	L078A
	  bne.s L05C2
	move.l	#$5F6F626A,d0
	bsr	L0850
	sf	$00DB(a6)
	trap	#$04
	bsr	L08BC
	  beq.s L05A2
	bsr	L0816
	trap	#$04
	bsr	L08BC
	  bne.s L05C2
L05A2	move.l	a0,d5
	moveq	#$47,d0 	; IOF_RHDR
	moveq	#$0E,d2
	moveq	#-$01,d3
	movea.l (a6),a1
	adda.w	#$0028,a1
	trap	#$04
	trap	#$03
	tst.l	d0
	  beq.s L05C8
L05B8	move.l	d0,d4
	movea.l d5,a0
	moveq	#$02,d0 	; IO_CLOSE
	trap	#$02
	move.l	d4,d0
L05C2	rts
L05C4	moveq	#-$0F,d0	; ERR_IPAR
	rts
L05C8	cmpi.b	#$01,-$09(a6,a1.l)
	  beq.s L05D4
	moveq	#-$0F,d0	; ERR_IPAR
	bra.s	L05B8
L05D4	moveq	#$01,d0 	; SMS_CRJB
	move.l	d7,d1
	move.l	-$0E(a6,a1.l),d2
	move.l	-$08(a6,a1.l),d3
	suba.l	a1,a1
	trap	#$01
	tst.l	d0
	  bne.s L05B8
	move.l	d1,d7
	movea.l a0,a1
	movea.l d5,a0
	moveq	#-$01,d3
	moveq	#$48,d0 	; IOF_LOAD
	trap	#$03
	bsr.s	L05B8
	tst.l	d0
	  beq.s L0606
L05FA	move.l	d0,d4
	moveq	#$04,d0 	; SMS_RMJB
	move.l	d7,d1
	trap	#$01
	move.l	d4,d0
	rts
L0606	moveq	#$00,d0 	; SMS_INFO
	trap	#$01
	movea.l $0068(a0),a2	; SYS_JBTB
	move.w	d7,d0
	lsl.w	#$02,d0
	adda.w	d0,a2
	movea.l (a2),a2
	tst.b	$00DB(a6)
	  beq.s L0626
	bsr	L06EE
	  bne.s L05FA
	moveq	#-$01,d5
	bra.s	L0670
L0626	moveq	#-$01,d5
L0628	movea.l a5,a3
	cmpa.l	a4,a3
	  beq.s L069C
	lea	$0008(a3),a5
	move.b	$01(a6,a3.l),d2
	  bmi	L0758
	cmpi.b	#$10,d2
	  bne.s L0646
	moveq	#-$01,d1
	bra	L076C
L0646	andi.b	#$0F,d2
	subq.b	#$01,d2
	  ble.s L0662
	tst.w	d5
	  bpl.s L0666
	bsr	L0748
	  bne.s L05FA
	move.w	$00(a6,a1.l),d5
	  bmi.s L0666
	addq.l	#$02,a1
	bra.s	L0628
L0662	tst.w	d6
	  beq.s L066A
L0666	moveq	#-$0F,d0	; ERR_IPAR
	bra.s	L05FA
L066A	bsr	L078A
	  bne.s L05FA
L0670	addq.l	#$02,a0
	move.w	d2,d1
	addq.w	#$03,d2
	bclr	#$00,d2
	movea.l $005C(a2),a1
	suba.w	d2,a1
	move.l	a1,$005C(a2)
	clr.w	(a1)+
	move.w	d1,(a1)+
	  beq.s L0696
	subq.b	#$01,d1
L068C	move.b	$00(a6,a0.l),(a1)+
	addq.l	#$01,a0
	dbf	d1,L068C
L0696	tst.b	$00DB(a6)
	  beq.s L0628
L069C	tst.w	d6
	  beq.s L06D0
	movea.l $005C(a2),a1
	suba.w	d6,a1
	move.l	a1,$005C(a2)
	lsr.w	#$02,d6
	move.w	d6,(a1)+
	movea.l (a6),a0
	moveq	#$00,d0
L06B2	cmpi.w	#$0001,d0
	  bne.s L06BE
	move.l	$00(a6,a0.l),d1
	bra.s	L06C2
L06BE	move.l	$00(a6,a0.l),(a1)+
L06C2	addq.l	#$01,d0
	addq.l	#$04,a0
	cmp.w	d0,d6
	  bne.s L06B2
	subq.b	#$01,d6
	  beq.s L06D0
	move.l	d1,(a1)+
L06D0	move.l	d7,d1
	move.b	d5,d2
	  bpl.s L06D8
	moveq	#$08,d2
L06D8	andi.b	#$7F,d2
	swap	d6
	ext.l	d6
	move.l	d6,d3
	moveq	#$0A,d0 	; SMS_ACJB
	trap	#$01
	tst.l	d0
	  bne	L05FA
	rts
L06EE	movea.l (a6),a0
	move.w	$00(a6,a0.l),d2
	subq.w	#$02,d2
	movea.l a0,a1
	adda.w	d2,a0
	move.b	#$20,$00(a6,a0.l)
	move.b	#$20,$01(a6,a0.l)
	addq.l	#$02,a0
	btst	#$00,d2
	  beq.s L0712
	subq.l	#$01,a0
	subq.w	#$01,d2
L0712	move.w	d2,$00(a6,a1.l)
	movea.l a5,a3
	lea	$0008(a3),a5
	cmpa.l	a3,a4
	  beq.s L0742
	move.l	a0,(a6)
	movem.l d2/a1,-(a7)
	bsr	L07CC
	movem.l (a7)+,d1/a1
	move.l	a1,(a6)
	tst.l	d0
	  bne.s L0746
	add.w	d1,d2
	addq.w	#$02,d2
	move.w	d2,$00(a6,a1.l)
	move.w	#$2020,$00(a6,a0.l)
L0742	movea.l a1,a0
	moveq	#$00,d0
L0746	rts
L0748	movem.l d2/d6/a2,-(a7)
	movea.w $00000112,a2
	jsr	(a2)
	movem.l (a7)+,d2/d6/a2
	rts
L0758	bsr.s	L0748
	  bne	L05FA
	bsr.s	L077A
	move.l	$00(a6,a0.l),d1
	  bpl.s L076C
	moveq	#-$06,d0	; ERR_ICHN
	bra	L05FA
L076C	movea.l (a6),a0
	adda.w	d6,a0
	move.l	d1,$00(a6,a0.l)
	addq.w	#$04,d6
	bra	L0628
L077A	movea.l $0030(a6),a0
	moveq	#$28,d0
	mulu.w	$00(a6,a1.l),d0
	addq.w	#$02,a1
	adda.l	d0,a0
	rts
L078A	moveq	#$00,d0
	move.w	$00(a6,a3.l),d0
	andi.w	#$FF0F,d0
	cmpi.w	#$0201,d0
	  beq.s L07CC
	move.w	$02(a6,a3.l),d0
	  bmi.s L07EA
	lsl.w	#$03,d0
	add.l	$0018(a6),d0
	movea.l d0,a3
	bsr.s	L07EE
L07AA	move.w	d2,d0
	  beq.s L07C2
	subq.w	#$01,d0
	movea.l (a6),a0
	addq.l	#$02,a0
L07B4	move.b	$00(a6,a1.l),$00(a6,a0.l)
	addq.l	#$01,a1
	addq.l	#$01,a0
	dbf	d0,L07B4
L07C2	movea.l (a6),a0
	move.w	d2,$00(a6,a0.l)
	moveq	#$00,d0
	rts
L07CC	movem.l d6/a2,-(a7)
	movea.w $00000116,a2
	jsr	(a2)
	movem.l (a7)+,d6/a2
	  bne.s L07EA
	move.w	$00(a6,a1.l),d2
	cmpi.w	#$007F,d2
	  bgt.s L07EA
	addq.l	#$02,a1
	bra.s	L07AA
L07EA	moveq	#-$0F,d0	; ERR_IPAR
	rts
L07EE	movea.l $0020(a6),a1
	moveq	#$00,d2
	move.w	$02(a6,a3.l),d2
	adda.l	d2,a1
	moveq	#$00,d2
	move.b	$00(a6,a1.l),d2
	lea	$0001(a1),a1
	rts
L0806	moveq	#$00,d0 	; SMS_INFO
	trap	#$01
	move.l	$00AC(a0),d1	; SYS_PRGD
	  beq.s L084C
	moveq	#$38,d0
	add.l	d0,d1
	bra.s	L0820
L0816	moveq	#$00,d0 	; SMS_INFO
	trap	#$01
	move.l	$00AC(a0),d1	; SYS_PRGD
	  beq.s L084C
L0820	movea.l d1,a2
	move.w	(a2)+,d1
	  beq.s L084C
	move.w	sr,d3
	trap	#$00		; SMS_SUPERV
	movea.l (a6),a0
	adda.l	a6,a0
	move.w	(a0),d0
	move.w	d0,d2
	add.w	d1,d2
	move.w	d2,(a0)+
	movea.l a0,a3
	adda.w	d0,a0
	lea	$00(a0,d1.w),a1
L083E	move.b	-(a0),-(a1)
	subq.w	#$01,d0
	  bne.s L083E
L0844	move.b	(a2)+,(a3)+
	subq.w	#$01,d1
	  bne.s L0844
	move.w	d3,sr
L084C	movea.l (a6),a0
	rts
L0850	lea	$02(a0,d2.w),a1
	moveq	#$03,d1
L0856	rol.l	#$08,d0
	move.b	d0,$00(a6,a1.l)
	addq.l	#$01,a1
	dbf	d1,L0856
	addq.w	#$04,d2
	move.w	d2,$00(a6,a0.l)
	rts
L086A	movem.l d1-d3/a0-a2,-(a7)
	movea.w $000000D0,a2	; UT_WTEXT
	suba.l	a0,a0
	jsr	(a2)
	movem.l (a7)+,d1-d3/a0-a2
	rts
	dc.w	$0013
	dc.b	'Creating work file',$0A,$00
L0892	dc.w	$0012
	dc.b	'Work file created',$0A
L08A6	dc.w	$0014
	dc.b	'Loading Q_Liberator',$0A
L08BC	moveq	#$01,d3
L08BE	moveq	#-$01,d1
	moveq	#$01,d0 	; IO_OPEN
	trap	#$02
L08C4	tst.l	d0
	rts


; =============== S U B R O U T I N E =======================================

; bytes = FREE

FREE
		moveq	#0,d0
		trap	#1
		move.l	sys_sbab(a0),d0 ; 'QL SuperBASIC' Area Base
		sub.l	sys_fsbb(a0),d0 ; Filing system Slave Block area Base
		movea.l sb_arthp(a6),a1 ; long	  arithmetic stack pointer
;		bra	ret_long_d0

; ---------------------------------------------------------------------------

ret_long_d0:				
		move.w	#$81F,d1
		tst.l	d0
		beq.s	ret_long_0

ret_long_normalize:
		asl.l	#1,d0
		bvs.s	ret_long_backtrack
		subq.w	#1,d1
		bra.s	ret_long_normalize
; ---------------------------------------------------------------------------

ret_long_0:
		clr.w	d1
		bra.s	ret_long_put
; ---------------------------------------------------------------------------

ret_long_backtrack:
		roxr.l	#1,d0

ret_long_put:				
		move.l	d0,-4(a6,a1.l)
		move.w	d1,-6(a6,a1.l)
		subq.l	#6,a1
		moveq	#2,d4
		move.l	a1,sb_arthp(a6) ; long	  arithmetic stack pointer
		moveq	#0,d0
		rts

*
	end
